<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>gluon: checks/checks.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">gluon
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_1abab4d757f86d382fea5dfa8cdf1fc3.html">checks</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">checks.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="checks_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;</div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#ifndef CHECKS_H</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#define CHECKS_H</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;</div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;</div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#ifdef __cplusplus</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;{</div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;</div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="preprocessor">#include &lt;stdint.h&gt;</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment">// addition a + b results in unsigned integer wrap</span></div><div class="line"><a name="l00020"></a><span class="lineno"><a class="line" href="checks_8h.html#a73a88126cb5a68f140354e51ffa1bb48">   20</a></span>&#160;<span class="preprocessor">#define ADD_UINT64_WRAPS(a, b) (UINT64_MAX - a &lt; b)</span></div><div class="line"><a name="l00021"></a><span class="lineno"><a class="line" href="checks_8h.html#af27751fa54ede07b9ce8cb537ce84450">   21</a></span>&#160;<span class="preprocessor">#define ADD_UINT32_WRAPS(a, b) (UINT32_MAX - a &lt; b)</span></div><div class="line"><a name="l00022"></a><span class="lineno"><a class="line" href="checks_8h.html#a1f4881d8ea242a2356e82b1fa8706d8b">   22</a></span>&#160;<span class="preprocessor">#define ADD_UINT16_WRAPS(a, b) (UINT16_MAX - a &lt; b)</span></div><div class="line"><a name="l00023"></a><span class="lineno"><a class="line" href="checks_8h.html#a599548d88482f8e91f345a0e5645d9bf">   23</a></span>&#160;<span class="preprocessor">#define ADD_UINT8_WRAPS(a, b) (UINT8_MAX - a &lt; b)</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment">// subtraction a - b results in unsigned integer wrap</span></div><div class="line"><a name="l00026"></a><span class="lineno"><a class="line" href="checks_8h.html#af178ceb736d6ed5678e1a3245ed005d4">   26</a></span>&#160;<span class="preprocessor">#define SUB_U_WRAPS(a, b) (a &lt; b)</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="comment">// cast of a to next smaller type would lose data</span></div><div class="line"><a name="l00029"></a><span class="lineno"><a class="line" href="checks_8h.html#a319eab81855471921c64c9811568d95e">   29</a></span>&#160;<span class="preprocessor">#define UINT64_TO_UINT32_LOSS(a) (a &gt; UINT32_MAX)</span></div><div class="line"><a name="l00030"></a><span class="lineno"><a class="line" href="checks_8h.html#a0d2692aba22265de50090e52cad6d89c">   30</a></span>&#160;<span class="preprocessor">#define UINT32_TO_UINT16_LOSS(a) (a &gt; UINT16_MAX)</span></div><div class="line"><a name="l00031"></a><span class="lineno"><a class="line" href="checks_8h.html#ae2356ecefba09f816cb8912fba37cf58">   31</a></span>&#160;<span class="preprocessor">#define UINT16_TO_UINT8_LOSS(a) (a &gt; UINT8_MAX)</span></div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="comment">// cast from unsigned to signed would would lose data</span></div><div class="line"><a name="l00034"></a><span class="lineno"><a class="line" href="checks_8h.html#a800ffb9294adf32e0544a9af9916c50b">   34</a></span>&#160;<span class="preprocessor">#define UINT64_TO_INT64_LOSS(a) (a &gt; INT64_MAX)</span></div><div class="line"><a name="l00035"></a><span class="lineno"><a class="line" href="checks_8h.html#a6d17f4f306188e5ec0d4bb7077b1bd5d">   35</a></span>&#160;<span class="preprocessor">#define UINT32_TO_INT32_LOSS(a) (a &gt; INT32_MAX)</span></div><div class="line"><a name="l00036"></a><span class="lineno"><a class="line" href="checks_8h.html#a09875c25cc5338183a477eb92f5d0e2a">   36</a></span>&#160;<span class="preprocessor">#define UINT16_TO_INT16_LOSS(a) (a &gt; INT16_MAX)</span></div><div class="line"><a name="l00037"></a><span class="lineno"><a class="line" href="checks_8h.html#a0a083dcd88d02f6161c6c3639a2ae630">   37</a></span>&#160;<span class="preprocessor">#define UINT8_TO_INT8_LOSS(a) (a &gt; INT8_MAX)</span></div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="preprocessor">#ifdef __cplusplus</span></div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;}</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="preprocessor">#endif</span></div></div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
